import opennlp.common.morph.*;
import opennlp.common.util.*;
import opennlp.maxent.*;

import opennlp.tools.util.BeamSearchContextGenerator;


import java.io.*;
import java.util.*;
import java.util.regex.*;

public class PentaContextGenerator extends TriContextGenerator implements BeamSearchContextGenerator {

    public ArrayList auxGetContext(int index, Object[] words, Object[] tags, String[] stags, Object[] additionalContext) {

	String nnnext, tagnnnext, tagnnnexta, nnnnext, tagnnnnext, tagnnnnexta;
	String cnnext, ctnnext, atnnext, cnnnext, ctnnnext, atnnnext;

	nnnext=tagnnnext=tagnnnexta=nnnnext=tagnnnnext=tagnnnnexta=null;
	cnnext=ctnnext=atnnext=cnnnext=ctnnnext=atnnnext=null;

	ArrayList e = super.auxGetContext(index, words, tags, stags, additionalContext);

	if (words.length>index+2) {
	    if (words.length>index+3) {
		nnnext = (String) words[index+3];
		tagnnnext = (String) tags[index+3];
		tagnnnexta = getSimpleTag(tagnnnext);
		cnnext = nnext+"_"+nnnext;
		ctnnext = tagnnext + "_" + tagnnnext;
		atnnext = tagnnexta + "_" + tagnnnexta;
		
		if (words.length>index+4) {
		    nnnnext = (String) words[index+4];
		    tagnnnnext = (String) tags[index+4];
		    tagnnnnexta = getSimpleTag(tagnnnnext);
		    
		    cnnnext = nnnext+"_"+nnnnext;
		    ctnnnext = tagnnnext + "_" + tagnnnnext;
		    atnnnext = tagnnnexta + "_" + tagnnnnexta;
		} else {
		    nnnnext = "*SE*";
		    tagnnnnext = "*SE*";
		}
	    } else {
		nnnext = "*SE*";
		tagnnnext = "*SE*";
	    }
	}
	
	if (nnnext!=null) {
	    e.add("nnn="+nnnext);
	    if(tagnnnext!=null) {
		e.add("uuu="+tagnnnext);
	    }
	    if(tagnnnexta!=null) {
		e.add("yyy="+tagnnnexta);
	    }
	    if(cnnext!=null) {
		e.add("cnn="+cnnext);
	    }
	    if(ctnnext!=null) {
		e.add("ctnn="+ctnnext);
	    }
	    if(atnnext!=null) {
		e.add("atnn="+atnnext);
	    }
	    if (nnnnext!=null) {
		e.add("nnnn="+nnnnext);
		if(tagnnnnext!=null) {
		    e.add("uuuu="+tagnnnnext);
		}
		if(tagnnnnexta!=null) {
		    e.add("yyyy="+tagnnnnexta);
		}
		if(cnnnext!=null) {
		    e.add("cnnn="+cnnnext);
		}
		if(ctnnnext!=null) {
		    e.add("ctnnn="+ctnnnext);
		}
		if(atnnnext!=null) {
		    e.add("atnnn="+atnnnext);
		}
	    }

	}

	return e;

    }

    public static void main(String[] args) {
	  
	  PentaContextGenerator gen = new PentaContextGenerator();
    
	  String[] lex =  {"zoals", "al", "gezegd", "we", "zijn", "dan", "toe", "aan", "agendapunt", "negen"};
	  String[] tags = {"vg2",   "bw", "ww7",   "vnw1", "ww2", "bw", "vz2", "vz1", "n1", "tw1"};
	  String[] stags = {"1860", "1484", "229", "148", "366", "1484", "1001", "1001", "148", "495"};

	  Pair[] p = mergeSequences(lex, tags);
	  String[] ans1 = gen.getContext(2, p, stags, null);
	  String[] ans2 = gen.getContext(6, p, stags, null);

	  for(int i=0; i<ans1.length; i++)
	      System.out.println(ans1[i]);
	  System.out.println();
	  for(int i=0; i<ans2.length; i++)
	      System.out.println(ans2[i]);
    }


}