
import java.awt.*;
import java.awt.event.*;
import javax.swing.*;

import java.io.*;
import java.util.*;

import org.jdom.*;

import opennlp.common.preprocess.*;
import opennlp.common.xml.*;
import opennlp.common.util.*;

import opennlp.maxent.*;
import opennlp.maxent.io.*;

public class TriEvaluationME {

    public static String removeResults(String ts) {

	StringBuffer sb = new StringBuffer();
	StringTokenizer st = new StringTokenizer(ts);
	String s = null;
	int i;

	while(st.hasMoreTokens()) {
	    s = st.nextToken();
	    i = s.lastIndexOf("/");
	    sb.append(s.substring(0,i)+" ");
	}

	return sb.toString().trim();
    }

    public static void main(String[] args) {

	try {

	    int solutions, beamsize;
	    if (args.length >= 3) {
		if (args.length >= 4) {
		    solutions = Integer.parseInt(args[3]);
		} else {
		    solutions = 1;
		}
		System.out.println("Solutions: "+solutions);
		if (args.length >= 5) {
		    beamsize = Integer.parseInt(args[4]);
		} else {
		    beamsize = 3*solutions;
		}
		System.out.println("Beam size: "+beamsize);
		System.out.print("Reading model...");
                TriSuperTaggerME st = new TriSuperTaggerME(beamsize, new SuffixSensitiveGISModelReader(new File(args[2])).getModel(), new TriContextGenerator());
		System.out.println("done!");
		// count the number of lines
		BufferedReader tmp = new BufferedReader(new FileReader(args[0]));
		int totallines = 0;
		while (tmp.readLine() != null) {
		    totallines++;
		}
		tmp.close();

		BufferedReader inf = new BufferedReader(new FileReader(args[0]));
		PrintWriter outf = new PrintWriter(new FileWriter(args[1]));

		int lines = 0;
		String line = null;

		while ((line=inf.readLine()) != null) {
		    line = removeResults(line);
		    outf.println(st.supertag(solutions, line.replace('_','/')));
		    System.out.print(".");
		    lines++;
		}

		System.out.println();
		outf.close();
		inf.close();

		System.exit(0);

	    } else {
		System.out.println("Usage: java TriEvaluationME infile outfile model [solutions] [beamsize]");
	    }
	} catch (IOException e) {
	    System.err.println(e);
	    System.exit(1);
	}
    }
}
